
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
//                    
//        File Name:  NPCManager.h 
//      Description:  A simple Manager pattern that both creates and manages NPC Objects.
//           Author:  Ashley W Matheson. 
//                    
//        Copyright:  
//                    Confidential and Proprietary Source Code For: 
//                           Yeah ... Right, Productions. 
//                        20351 83rd Ave, Langley, BC 
//                    
//        Revisions:  
//                    04/08/2002 - AWM - Original version. 
//                    
//  Copyright (c) 2002, Yeah ... Right, Productions. All rights reserved. 
//                    
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 

#ifndef __NPCMANAGER_H__
#define __NPCMANAGER_H__

#include "NPCObject.h"
#include <list>
extern "C"
{
	#include <lua.h>
}
using namespace std;


typedef list<NPCObject*> NPCList;
typedef NPCList::iterator NPCItor;

#define theNPCManager (NPCManager::Instance())
class NPCManager
{
public:
	virtual ~NPCManager();

	static NPCManager* Instance() ;

	void AddNPC(const char* name);
	void DeleteNPC(const char* name);
	void Dump();

protected:
	NPCManager();

	static NPCManager*	_instance;

	NPCList	m_NPCList;

};

// Binding functions declarations
int l_addNPC( lua_State* luaVM);
int l_deleteNPC( lua_State* luaVM);

#endif //__NPCMANAGER_H__