///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
//                    
//        File Name:  NPCObject.cpp 
//      Description:  Implementation of class NPCObect
//           Author:  Ashley W Matheson. 
//                    
//        Copyright:  
//                    Confidential and Proprietary Source Code For: 
//                           Yeah ... Right, Productions. 
//                        20351 83rd Ave, Langley, BC 
//                    
//        Revisions:  
//                    04/08/2002 - AWM - Original version. 
//                    
//  Copyright (c) 2002, Yeah ... Right, Productions. All rights reserved. 
//                    
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include "NPCObject.h"
#include <string.h>

// Constructor/Destructor pairing
NPCObject::NPCObject()
{
	m_strName = NULL;
}

NPCObject::~NPCObject()
{
	if (m_strName)
		delete m_strName;
}

///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
//                    
//      Method Name:  NPCObject::SetName 
//          Summary:  Sets the internal name of this object.  
//                    
//       Parameters:  const char* name
// 
//          Returns:  void  
//                    
//      Description:  I don't do this in the constructor simply
//					  because I prefer doing this kind of operation outside of the c-tor.  Yes, I know
//					  this would be the functionality of a copy c-tor and may cause some problems in a 
//					  deep copy, but this is an example of lua, not copy c-tors.
//                    
//         See Also:  
//                    
//           Author:  Ashley W Matheson. 
//                    
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
void NPCObject::SetName(const char* name)
{
	if (m_strName)
		delete m_strName;
	m_strName = new char[strlen(name)+1];
	strcpy(m_strName, name);
}

///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
//                    
//      Method Name:  NPCObject::GetName 
//          Summary:  Return the internal name of this NPC
//                    
//       Parameters:  char* name
// 
//          Returns:  void  
//                    
//      Description:  Copys into a pointer the name of the NPC.  Assumes that the buffer is of adaquate 
//					  length
//                    
//         See Also:  
//                    
//           Author:  Ashley W Matheson. 
//                    
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
void NPCObject::GetName(char* name)
{
	strcpy(name, m_strName);
}