///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
//                    
//        File Name:  main.cpp 
//      Description:  Main entry point for our simple lua interpreter
//           Author:  Ashley W Matheson. 
//                    
//        Copyright:  
//                    Confidential and Proprietary Source Code For: 
//                           Yeah ... Right, Productions. 
//                        20351 83rd Ave, Langley, BC 
//                    
//        Revisions:  
//                    04/08/2002 - AWM - Original version. 
//                    
//  Copyright (c) 2002, Yeah ... Right, Productions. All rights reserved. 
//                    
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
#include <stdio.h>
#include <string.h>
extern "C"
{
#include <lua.h>
#include <lualib.h>
}

///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
//                    
//    Function Name:  main 
//          Summary:  Main entry point into our application
//                    
//       Parameters:  int argc
//                    char* argv[]
// 
//          Returns:  int  
//                    
//      Description:  We initialize lua, create a loop for handling input from the console
//					  and process the output
//                    
//         See Also:  lua_open; 
//                    
//           Author:  Ashley W Matheson. 
//                    
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
int main(int argc, char* argv[])
{
	lua_State* luaVM = lua_open(0);

	if (NULL == luaVM)
	{
		printf("Error Initializing lua\n");
		return -1;
	}

	// initialize lua standard library functions
	lua_baselibopen(luaVM);
    lua_iolibopen(luaVM);
    lua_strlibopen(luaVM);
    lua_mathlibopen(luaVM);

	printf("Simple Functional lua interpreter\n");
	printf("Based on lua version 4.0.1\n");
	printf("Enter lua commands. type 'exit<enter>' to exit\n");
	printf("\n>");

	lua_dofile(luaVM, "./startup.lua");

	lua_close(luaVM);

	return 0;
}