
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
//                    
//        File Name:  DisplayDevice.cpp 
//      Description:  Singleton that contains Device information.
//           Author:  Ash W. Matheson 
//                    
//        Copyright:  
//                    This code is Open to the general public for use  
//                        Yeah, ... Right Productions. 
//                        6666-182, Surrey, BC  
//                    
//        Revisions:  
//                    5/16/2002 - AWM - Original version. 
//                    
//  Copyright (c) 2001, Yeah, ... Right Productions. All rights reserved. 
//                    
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 

#include "DisplayDevice.h"

CDisplayDevice* CDisplayDevice::_instance = CDisplayDevice::Instance();

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDisplayDevice::CDisplayDevice()
{
	_instance = this;
	m_pD3DDevice = NULL;
}

CDisplayDevice::~CDisplayDevice()
{

}

CDisplayDevice* CDisplayDevice::Instance()
{
	if ( !_instance )
	{
		_instance = new CDisplayDevice();
	}
	return _instance;
}

void CDisplayDevice::Initialize(LPDIRECT3DDEVICE8 d3ddevice)
{
	m_pD3DDevice = d3ddevice;
}


HRESULT CDisplayDevice::RestoreDeviceObjects(LPDIRECT3DDEVICE8 d3ddevice)
{
	m_pD3DDevice = d3ddevice;
	return S_OK;
}

HRESULT CDisplayDevice::InvalidateDeviceObjects()
{
	m_pD3DDevice = NULL;
	return S_OK;
}

HRESULT CDisplayDevice::DeleteDeviceObjects()
{
	m_pD3DDevice = NULL;
	return S_OK;
}

LPDIRECT3DVERTEXBUFFER8 CDisplayDevice::CreateSprite()
{
	LPDIRECT3DVERTEXBUFFER8 pVB = NULL;	

    if(FAILED( m_pD3DDevice->CreateVertexBuffer( sizeof(POINTVERTEX), 
		D3DUSAGE_DYNAMIC | D3DUSAGE_WRITEONLY | D3DUSAGE_POINTS, 
		D3DFVF_POINTVERTEX, D3DPOOL_DEFAULT, &pVB )))
	{
        return NULL;
	}


	return pVB;
}
