
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 
//                    
//        File Name:  DisplayDevice.h 
//      Description:  Class that allows rapid access to the Display Device
//           Author:  Ash W. Matheson 
//                    
//        Copyright:  
//                    This code is Open to the general public for use  
//                        Yeah, ... Right Productions. 
//                        6666-182, Surrey, BC  
//                    
//        Revisions:  
//                    5/16/2002 - AWM - Original version. 
//                    
//  Copyright (c) 2001, Yeah, ... Right Productions. All rights reserved. 
//                    
///////////////////////////////////////////////////////////////////////////////////////////////////// 
///////////////////////////////////////////////////////////////////////////////////////////////////// 

#ifndef __CDISPLAYDEVICE_H__
#define __CDISPLAYDEVICE_H__

#include <D3DX8.h>

#define theDisplayDevice (CDisplayDevice::Instance())

//-----------------------------------------------------------------------------
// Custom vertex types
//-----------------------------------------------------------------------------
struct COLORVERTEX
{
    D3DXVECTOR3 v;
    D3DCOLOR    color;
    FLOAT       tu;
    FLOAT       tv;
};

#define D3DFVF_COLORVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1)

struct POINTVERTEX
{
    D3DXVECTOR3 v;
    D3DCOLOR    color;
};

#define D3DFVF_POINTVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE)

// Helper function to stuff a FLOAT into a DWORD argument
inline DWORD FtoDW( FLOAT f ) { return *((DWORD*)&f); }


class CDisplayDevice  
{
public:
	static CDisplayDevice* Instance();
	virtual ~CDisplayDevice();
	void Initialize(LPDIRECT3DDEVICE8 d3ddevice);
    HRESULT RestoreDeviceObjects(LPDIRECT3DDEVICE8 d3ddevice);
    HRESULT InvalidateDeviceObjects();
    HRESULT DeleteDeviceObjects();
	LPDIRECT3DDEVICE8 GetDevice() { return m_pD3DDevice; }
	LPDIRECT3DVERTEXBUFFER8 CreateSprite();

protected:
	CDisplayDevice();

protected:
	static CDisplayDevice* _instance;
	LPDIRECT3DDEVICE8	m_pD3DDevice;

};

#endif // __CDISPLAYDEVICE_H__
