#include "geometry.h"
#include "DisplayDevice.h"
#include "dxutil.h"
#include <string.h>

static int nCounter = 0;

CGeometry::CGeometry(void)
{
	m_pd3dSprite = NULL;
	m_strType	 = NULL;
}

CGeometry::~CGeometry(void)
{
	delete m_strType;

	SAFE_RELEASE(m_pd3dSprite);
}

unsigned int CGeometry::Initialize(char* type)
{
	Type(type);

	return 0;
}

char* CGeometry::Type(char* type)
{
	if ( type)	// Changing the type name
	{
		if ( m_strType )
		{
			delete m_strType;
			m_strType = NULL;
		}
		
		m_strType = new char[strlen(type) +1];
		strcpy(m_strType, type);
	}

	return m_strType;
}

void CGeometry::Draw()
{
	// Set the Stream Source
    theDisplayDevice->GetDevice()->SetStreamSource( 0, m_pd3dSprite, sizeof(POINTVERTEX) );

	// Set the Vertex Shader
    theDisplayDevice->GetDevice()->SetVertexShader( D3DFVF_POINTVERTEX );

	// Render the vertex buffer
	theDisplayDevice->GetDevice()->DrawPrimitive(D3DPT_POINTLIST, 0, 1);

}

void CGeometry::Restore()
{
	// Create this new Geometric object.
	m_pd3dSprite = theDisplayDevice->CreateSprite();

	// Lock the VB and populate it
    POINTVERTEX* pVertices;

	if(FAILED(m_pd3dSprite->Lock( 0, sizeof(POINTVERTEX),
								 (BYTE **) &pVertices, D3DLOCK_DISCARD)))
	{
		OutputDebugString("Failed to lock the Point Sprite Buffer\n");
		return;
	}

	pVertices->v		= D3DXVECTOR3(0.0f, 0.0f, 0.0f);
	pVertices->color	= D3DXCOLOR( 255,255,255,255);

	m_pd3dSprite->Unlock();
}

void CGeometry::Invalidate()
{
	SAFE_RELEASE( m_pd3dSprite );
}

void CGeometry::Destroy()
{
	Invalidate();
	delete m_strType;
}