// Ground.h: interface for the CGround class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __CGROUND_H__
#define __CGROUND_H__

#pragma once

#define GROUND_WIDTH     256.0f
#define GROUND_HEIGHT    256.0f
#define GROUND_GRIDSIZE  8
#define GROUND_TILE      32
#define GROUND_COLOR     0xcccccccc

#include <d3d8.h>
#include <d3dx8.h>

class CGround  
{
public:
	CGround();
	virtual ~CGround();

	void Initialize( char* texture );
	void Invalidate();
	void Restore();
	void Destroy();

	void Draw();


protected:
    // Ground stuff
    LPDIRECT3DTEXTURE8 m_pGroundTexture;
    D3DXPLANE          m_planeGround;

    LPDIRECT3DVERTEXBUFFER8 m_pGroundVB;
    LPDIRECT3DINDEXBUFFER8  m_pGroundIB;
    DWORD					m_dwNumGroundIndices;
    DWORD					m_dwNumGroundVertices;

	char*					m_strTextureFileName;
};

#endif // __CGROUND_H__
