// Particle.cpp: implementation of the CParticle class.
//
//////////////////////////////////////////////////////////////////////

#include "Particle.h"
#include <D3dx8math.h>
#include "D3DUtil.h"
#include "dxutil.h"

// Vertex buffer related data
// Vertext buffer information
struct POINTVERTEX
{
    D3DXVECTOR3 v;
    D3DCOLOR    color;
};

#define D3DFVF_POINTVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE)

// Helper function to stuff a FLOAT into a DWORD argument
inline DWORD FtoDW( FLOAT f ) { return *((DWORD*)&f); }

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CParticle::CParticle()
{
}

CParticle::~CParticle()
{
}

void CParticle::Initialize( D3DVECTOR* pPosition, D3DVECTOR* pTrajectory, D3DCOLOR* pDiffuse, float mass)
{
	// copy the memory ... should be faster
	memcpy(&m_vecPosition, pPosition, sizeof( D3DVECTOR ) );
	memcpy(&m_vecTrajectory, pTrajectory, sizeof( D3DVECTOR ) );
	memcpy(&m_colDiffuse, pDiffuse, sizeof( D3DVECTOR ) );
	m_nMass = mass;
}

void CParticle::Process()
{
	m_vecPosition.x += m_vecTrajectory.x*0.01f;
	m_vecPosition.y += m_vecTrajectory.y*0.01f;
	m_vecPosition.z += m_vecTrajectory.z*0.01f;
}