// ParticleSystem.h: interface for the CParticleSystem class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __CPARTICLESYSTEM_H_
#define __CPARTICLESYSTEM_H_

#pragma once

#include <d3d8.h>
#include "Particle.h"
#include "GeometryManager.h"
#include "TextureManager.h"
#include "DisplayDevice.h"
#include <list>

using namespace std;
typedef list<CParticle*> ParticleList;
typedef ParticleList::iterator	ParticleListItor;

class CParticleSystem  
{
public:
	CParticleSystem();
	virtual ~CParticleSystem();

	CParticle* Add(D3DVECTOR position, D3DVECTOR trajectory, D3DCOLOR diffuse, float mass);
	void Process();
	void Initialize( char* texture );
	void Invalidate();
	void Restore();
	void Destroy();

	void Draw();

protected:
	CGeometry*			m_pGeometry;
	CTexture*			m_pTexture;
	float				m_nPointSize;
	char*				m_strTextureName;

	ParticleList		m_listParticles;
};

#endif // __CPARTICLESYSTEM_H_
