//-----------------------------------------------------------------------------
// File: SmallParticles.h
//
// Desc: Header file SmallParticles sample app
//-----------------------------------------------------------------------------
#ifndef AFX_SMALLPARTICLES_H__5A2183B2_1AAF_4DC4_B453_77C9A65E4D57__INCLUDED_
#define AFX_SMALLPARTICLES_H__5A2183B2_1AAF_4DC4_B453_77C9A65E4D57__INCLUDED_


#include "ParticleSystem.h"
#include "Ground.h"
#include "script.h"

//-----------------------------------------------------------------------------
// Defines, and constants
//-----------------------------------------------------------------------------
// TODO: change "DirectX AppWizard Apps" to your name or the company name
#define DXAPP_KEY        TEXT("Software\\DirectX AppWizard Apps\\SmallParticles")

// Struct to store the current input state
struct UserInput
{
    BYTE diks[256];   // DirectInput keyboard state buffer 

    // TODO: change as needed
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
};


//-----------------------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: Application class. The base class (CD3DApplication) provides the 
//       generic functionality needed in all Direct3D samples. CMyD3DApplication 
//       adds functionality specific to this sample program.
//-----------------------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
    BOOL                    m_bLoadingApp;          // TRUE, if the app is loading
    CD3DFont*               m_pFont;                // Font for drawing text

    LPDIRECTINPUT8          m_pDI;                  // DirectInput object
    LPDIRECTINPUTDEVICE8    m_pKeyboard;            // DirectInput keyboard device
    UserInput               m_UserInput;            // Struct for storing user input 

    FLOAT                   m_fWorldRotX;           // World rotation state X-axis
    FLOAT                   m_fWorldRotY;           // World rotation state Y-axis

	CD3DCamera				m_Camera;				// Camera to use in the world.

	CScript					m_Script;
	
	friend void AddParticle(CMyD3DApplication* ref, D3DVECTOR position, D3DVECTOR trajectory, D3DCOLOR diffuse, float mass);

protected:
	CParticleSystem		m_BaseParticleSystem;
	CGround				m_Ground;


protected:
    HRESULT OneTimeSceneInit();
    HRESULT InitDeviceObjects();
    HRESULT RestoreDeviceObjects();
    HRESULT InvalidateDeviceObjects();
    HRESULT DeleteDeviceObjects();
    HRESULT Render();
    HRESULT FrameMove();
    HRESULT FinalCleanup();
    HRESULT ConfirmDevice( D3DCAPS8*, DWORD, D3DFORMAT );

    HRESULT RenderText();

    HRESULT InitInput( HWND hWnd );
    void    UpdateInput( UserInput* pUserInput );
    void    CleanupDirectInput();

    VOID    ReadSettings();
    VOID    WriteSettings();

public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
};


#endif // !defined(AFX_SMALLPARTICLES_H__5A2183B2_1AAF_4DC4_B453_77C9A65E4D57__INCLUDED_)
