// Texture.cpp: implementation of the CTexture class.
//
//////////////////////////////////////////////////////////////////////

#include "DisplayDevice.h"
#include "Texture.h"
#include <D3dx8tex.h>
#include "dxutil.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTexture::CTexture()
{
	m_pTextureData = NULL;
}

CTexture::~CTexture()
{
	delete m_strTextureName;
}

void CTexture::Initialize( char* filename)
{
	m_strTextureName = new char[ strlen( filename ) + 1];
	strcpy( m_strTextureName, filename );
}

void CTexture::Use(LPDIRECT3DDEVICE8 d3ddevice)
{
	if ( m_pTextureData )
		d3ddevice->SetTexture( 0, m_pTextureData );
}

void CTexture::Invalidate()
{
	SAFE_RELEASE( m_pTextureData );
}

void CTexture::Restore()
{
	D3DXCreateTextureFromFile(	theDisplayDevice->GetDevice(),	// The Device to create the Texture on
								m_strTextureName,						// The filename to load the texture from
								&m_pTextureData);				// The Texture Resource to create
}