// TextureManager.cpp: implementation of the CTextureManager class.
//
//////////////////////////////////////////////////////////////////////

#include "TextureManager.h"
CTextureManager* CTextureManager::_instance = CTextureManager::Instance();

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTextureManager::CTextureManager()
{
	_instance = this;
}

CTextureManager::~CTextureManager()
{

}


inline CTextureManager* CTextureManager::Instance()
{
	if (!_instance)
	{
		_instance = new CTextureManager();
	}
	return _instance;
}

CTexture* CTextureManager::Add( char* texturefilename )
{
	CTexture* pTexture = NULL;

	// Does this Texture already exist?
	for (	CTextureListItor itor = m_Textures.begin();
			itor != m_Textures.end();)
	{
		if ( strcmpi( (*itor)->GetName(), texturefilename ) == 0 )
		{
			pTexture = (*itor);
			break;
		}
		++itor;
	}

	if (pTexture == NULL)
	{
		pTexture = new CTexture();

		pTexture->Initialize( texturefilename );

		m_Textures.push_back( pTexture );
	}

	return pTexture;
}